/* devcaDIMClientSoft.c */
/* Example device support module */

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "alarm.h"
#include "cvtTable.h"
#include "dbDefs.h"
#include "dbAccess.h"
#include "recGbl.h"
#include "recSup.h"
#include "devSup.h"
#include "link.h"
#include "caDIMClientRecord.h"
#include "epicsExport.h"

/*DIM specific */
#include "dic.h"
/*DIM specific */

/*DIM declarations for one PV only!*/
void dim_call_back();
double no_link = -1;

#define MAX_DIMRecords 1000
static int  nofDIMRecords = 0;
static double* DIMC_Data[MAX_DIMRecords];
static int*  DIMC_Records[MAX_DIMRecords];
 
/*DIM declarations */


/*Create the dset for devcaDIMClientSoft */
static long init_record();
static long read_caDIMClient();
struct {
	long		number;
	DEVSUPFUN	report;
	DEVSUPFUN	init;
	DEVSUPFUN	init_record;
	DEVSUPFUN	get_ioint_info;
	DEVSUPFUN	read_caDIMClient;
}devcaDIMClientSoft={
	5,
	NULL,
	NULL,
	init_record,
	NULL,
	read_caDIMClient,
};
epicsExportAddress(dset,devcaDIMClientSoft);


static long init_record(pcaDIMClient)
    struct caDIMClientRecord	*pcaDIMClient;
{
    char dim_name[1024];
    if(recGblInitConstantLink(&pcaDIMClient->inp,DBF_DOUBLE,&pcaDIMClient->val)){
         pcaDIMClient->udf = FALSE;
    }
    strcpy(dim_name,pcaDIMClient->dimservicename);
    if(nofDIMRecords<MAX_DIMRecords){
	/* alloc memeory for DIM data */
	DIMC_Data[nofDIMRecords]=calloc(1, sizeof(double));
	/* store pointer to Record */
	DIMC_Records[nofDIMRecords]=(int*) pcaDIMClient;
	/*connect DIM service as client*/
	dic_info_service( dim_name, MONITORED, 0, 0, 0, dim_call_back, nofDIMRecords, &no_link, sizeof(double) );
	nofDIMRecords++;
    }
    return(0);
}

static long read_caDIMClient(pcaDIMClient)
    struct caDIMClientRecord	*pcaDIMClient;
{
    long status;
    int ii=0;

    for(ii=0;ii<MAX_DIMRecords;ii++){
	if(DIMC_Records[ii]==(int*) pcaDIMClient) break;
    }

    /* copy DIM data buffer to record value */
    pcaDIMClient->val = *DIMC_Data[ii];
    /*    printf("<i> devcaDIMClientSoft.c: read_caDIMClient: Recordnum %d : dim_data =%f \n", ii, pcaDIMClient->val);*/
    status = dbGetLink(&(pcaDIMClient->inp),DBF_DOUBLE, &(pcaDIMClient->val),0,0);
    /*If return was succesful then set undefined false*/
    if(!status) pcaDIMClient->udf = FALSE;
    return(0);
}

void dim_call_back( tag, data, size )
double *data;
int *tag, *size;
{
    if(*data == -1)
	printf("<i> devcaDIMClientSoft.c: dim_call_back: Server is dead and/or Service not available \n");
    else{
      /* printf("<i> devcaDIMClientSoft.c: dim_call_back: Tag: %d, dim_data: %d\n",(int)*tag, *data);*/
	*DIMC_Data[(int)*tag]=*data;
    }
}



