/* devcaDIMServerSoft.c */
/* Example device support module */

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "alarm.h"
#include "cvtTable.h"
#include "dbDefs.h"
#include "dbAccess.h"
#include "recGbl.h"
#include "recSup.h"
#include "devSup.h"
#include "link.h"
#include "caDIMServerRecord.h"
#include "epicsExport.h"

/*DIM specific */
#include "dic.h"
/*DIM specific */

/*DIM declarations for one PV only!*/
void dim_call_back();
int no_link = -1;

#define MAX_DIMRecords 1000
static int  nofDIMRecords = 0;
static int* DIMC_Data[MAX_DIMRecords];
static int*  DIMC_Records[MAX_DIMRecords];
 
/*DIM declarations */


/*Create the dset for devcaDIMServerSoft */
static long init_record();
static long read_caDIMServer();
struct {
	long		number;
	DEVSUPFUN	report;
	DEVSUPFUN	init;
	DEVSUPFUN	init_record;
	DEVSUPFUN	get_ioint_info;
	DEVSUPFUN	read_caDIMServer;
}devcaDIMServerSoft={
	5,
	NULL,
	NULL,
	init_record,
	NULL,
	read_caDIMServer,
};
epicsExportAddress(dset,devcaDIMServerSoft);


static long init_record(pcaDIMServer)
    struct caDIMServerRecord	*pcaDIMServer;
{
    char dim_name[1024];
    if(recGblInitConstantLink(&pcaDIMServer->inp,DBF_DOUBLE,&pcaDIMServer->val)){
         pcaDIMServer->udf = FALSE;
    }
    strcpy(dim_name,pcaDIMServer->dimservicename);
    if(nofDIMRecords<MAX_DIMRecords){
	/* alloc memeory for DIM data */
	DIMC_Data[nofDIMRecords]=calloc(1, sizeof(int));
	/* store pointer to Record */
	DIMC_Records[nofDIMRecords]=(int*) pcaDIMServer;
	/*connect DIM service as client*/
	dic_info_service( dim_name, MONITORED, 0, 0, 0, dim_call_back, nofDIMRecords, &no_link, 4 );
	nofDIMRecords++;
    }
    return(0);
}

static long read_caDIMServer(pcaDIMServer)
    struct caDIMServerRecord	*pcaDIMServer;
{
    long status;
    int ii=0;

    for(ii=0;ii<MAX_DIMRecords;ii++){
	if(DIMC_Records[ii]==(int*) pcaDIMServer) break;
    }

    /* copy DIM data buffer to record value */
    pcaDIMServer->val = (double) *DIMC_Data[ii];
    printf("<i> devcaDIMServerSoft.c: read_caDIMServer: Recordnum %d : dim_data =%f \n", ii, pcaDIMServer->val);
    
    status = dbGetLink(&(pcaDIMServer->inp),DBF_DOUBLE, &(pcaDIMServer->val),0,0);
    /*If return was succesful then set undefined false*/
    if(!status) pcaDIMServer->udf = FALSE;
    return(0);
}

void dim_call_back( tag, data, size )
int *data;
int *tag, *size;
{
    if(*data == -1)
	printf("<i> devcaDIMServerSoft.c: dim_call_back: Server is dead and/or Service not available \n");
    else{
	printf("<i> devcaDIMServerSoft.c: dim_call_back: Tag: %d, dim_data: %d\n",(int)*tag, *data);
	*DIMC_Data[(int)*tag]=(int)*data;
    }
}



